#!/usr/bin/perl

#┌─────────────────────────────────
#│ ImageAlbum v4.02 : admin.cgi - 2013/01/03
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Image Album v5.2 : admin.cgi - 2022/10/01
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&error('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 条件分岐
if ($in{mode_add}) { mode_add(); }
if ($in{mode_men}) { mode_mente(); }
if ($in{mode_res}) { mode_res(); }
if ($in{data_cat}) { data_cat(); }
if ($in{pass_mgr}) { pass_mgr(); }

menu_top();

#-----------------------------------------------------------
#  管理TOP
#-----------------------------------------------------------
sub menu_top {
	header("管理メニュー");
	print <<EOM;
<div class="all">
<div align="center">
▼処理を選択してください。
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl">
<tr>
  <th colspan="2">管理メニュー</th>
</tr><tr>
  <th>選択</th><th width="280">項目</th>
</tr><tr>
  <td class="center"><input type="submit" name="data_cat" class="button" value="選択"></td>
  <td>&nbsp; カテゴリー設定</td>
</tr><tr>
  <td class="center"><input type="submit" name="mode_add" class="button" value="選択"></td>
  <td>&nbsp; 画像データ追加</td>
</tr><tr>
  <td class="center"><input type="submit" name="mode_men" class="button" value="選択"></td>
  <td>&nbsp; 画像データ修正＆削除</td>
</tr><tr>
  <td class="center"><input type="submit" name="mode_res" class="button" value="選択"></td>
  <td>&nbsp; 返信記事の管理(修正・削除)</td>
</tr><tr>
  <td class="center"><input type="submit" name="pass_mgr" class="button" value="選択"></td>
  <td>&nbsp; パスワード管理</td>
</tr><tr>
  <td class="center"><input type="button" value="選択" class="button" onclick=window.open("$cf{album_cgi}","_top")></td>
  <td>&nbsp; 表\示画面</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  画像データ追加
#-----------------------------------------------------------
sub mode_add {
	my ($no,$sub,$msg,$ex,$w,$h,undef,undef,$cat) = @_;

	# 登録
	if ($in{mode_add} eq "add") {

		# チェック
		my $err;
		if (!$in{sub}) { $err .= "タイトルが未入力です<br>\n"; }
		if (!$in{upfile}) { $err .= "画像が未入力です<br>\n"; }
		if ($err) { &error($err); }

		# 時間
		my $time = time;

		# 採番
		open(DAT,"+< $cf{numfile}") or &error("open err: $cf{numfile}");
		my $data = <DAT>;
		my ($num,$cat) = split(/<>/,$data);
		$num++;
		seek(DAT, 0, 0);
		print DAT "$num<>$cat";
		truncate(DAT, tell(DAT));
		close(DAT);

		# 画像アップ
		my ($ex,$w,$h) = upload($num);
		if (!$ex) { error("画像アップに失敗しました"); }

		# データ読み込み
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		my @data = <DAT>;
		seek(DAT, 0, 0);
		print DAT "$num<>$in{sub}<>$in{msg}<>$ex<>$w<>$h<>0<>$time<>$in{cat}<>\n";
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		message("記事を追加しました");

	}

	# カテゴリ
	my $cat_op = qq|<option value="">▼選択\n|;
	open(IN,"$cf{catfile}") or error("open err: $cf{catfile}");
	while(<IN>) {
		my ($no,$cate) = split(/<>/);

		if ($in{cat} == $no) {
			$cat_op .= qq|<option value="$no" selected>$cate\n|;
		} else {
			$cat_op .= qq|<option value="$no">$cate\n|;
		}
	}
	close(IN);

	header("画像データ追加 / 修正");
	print <<EOM;
<div class="all">
<br />
EOM
	back_btn();
	print <<EOM;
<div class="sub-ttl"> 画像データ追加 / 修正</div>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
EOM

	$msg =~ s|<br( /)?>|\n|g;

	if ($in{no}) {
		print qq|<input type="hidden" name="mode_men" value="1">\n|;
		print qq|<input type="hidden" name="job" value="edit">\n|;
		print qq|<input type="hidden" name="no" value="$in{no}">\n|;
	} else {
		print qq|<input type="hidden" name="mode_add" value="add">\n|;
	}

	print <<EOM;
<table class="deco2">
<tr>
  <th>タイトル</th>
  <td><input type="text" name="sub" size="40" value="$sub"></td>
</tr><tr>
  <th nowrap>カテゴリー</th>
  <td>
	<select name="cat">
	$cat_op
	<select>
  </td>
</tr><tr>
  <th>メッセージ</th>
  <td><textarea name="msg" cols="56" rows="7">$msg</textarea></td>
</tr><tr>
	<th>画像</th>
	<td nowrap>
		（JPEG/GIF/PNG/BMP）<br>
		<input type="file" name="upfile" size="40"><br />
EOM

	if ($ex) {
		($w,$h) = resize($w,$h,$cf{max_w},$cf{max_h});
		print qq|<br><a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{uplurl}/$no$ex" width="$w" height="$h" border="no" class="snapshot"></a>|;
	}

	print <<EOM;
  </td>
</tr>
</table>
<input type="submit" class="button" value="送信する">
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  画像データメンテ
#-----------------------------------------------------------
sub mode_mente {
	# 削除
	if ($in{job_dele} && $in{no}) {

		# 削除情報
		my %del;
		foreach ( $cgi->param('no') ) {
			$del{$_}++;
		}

		# ログ展開
		my @data;
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			# 削除情報マッチ
			if (defined($del{$no})) {
				unlink("$cf{upldir}/$no$ex");
				unlink("$cf{upldir}/$no-s$ex") if (-f "$cf{upldir}/$no-s$ex");
				next;
			}
			push(@data,$_);
		}

		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 採番更新
		open(DAT,"+< $cf{numfile}") or error("open err: $cf{numfile}");
		my $data = <DAT>;
		my ($num,$cat) = split(/<>/, $data);
		my $number = $num - 1;
		seek(DAT, 0, 0);
		print DAT "$number<>$cat";
		truncate(DAT, tell(DAT));
		close(DAT);

	# 修正フォーム
	} elsif ($in{job_edit} && $in{no}) {

		# ログ展開
		my @log;
		open(IN,"$cf{datfile}") or &error("open err: $cf{datfile}");
		while (<IN>) {
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat);
				last;
			}
		}
		close(IN);

		mode_add(@log);

	# 修正実行
	} elsif ($in{job} eq "edit") {

		# チェック
		if (!$in{sub}) { error("タイトルが未入力です"); }

		# 画像アップ
		my ($ex2,$w2,$h2);
		if ($in{upfile}) {
			($ex2,$w2,$h2) = &upload($in{no});
		}

		# ログ展開
		my @data;
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			chomp;
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			if ($in{no} == $no) {
				if ($ex2) {
					if ($ex2 ne $ex) {
						unlink("$cf{upldir}/$no$ex");
						unlink("$cf{upldir}/$no-s$ex") if (-f "$cf{upldir}/$no-s$ex");
					}
					$ex = $ex2;
					$w = $w2;
					$h = $h2;
				}
				$_ = "$no<>$in{sub}<>$in{msg}<>$ex<>$w<>$h<>$res<>$time<>$in{cat}<>";
			}
			push(@data,"$_\n");
		}
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		message("記事を修正しました");

	# ソート
	} elsif ($in{job_sort}) {

		# ログ展開
		my ($i,@tmp1,@tmp2,@data);
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			$i++;
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			# 他カテゴリ用
			if ($in{"sort:$no"} eq '') { $in{"sort:$no"} = $i; }

			push(@tmp1,$cat);
			push(@tmp2,$in{"sort$no"});
			push(@data,$_);
		}

		# カテゴリ順 → 指定順にソート
		@data = @data[sort{$tmp1[$a] <=> $tmp1[$b] || $tmp2[$a] <=> $tmp2[$b]} 0 .. $#tmp1];

		# データ更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# カテゴリ
	my ($i,$cat_op,%cat);
	open(IN,"$cf{catfile}") or error("open err: $cf{catfile}");
	while(<IN>) {
		$i++;
		my ($no,$cat) = split(/<>/);

		$cat{$no} = $cat;

		if ($in{cat} == $no) {
			$cat_op .= qq|<option value="$no" selected>$cat\n|;
		} else {
			$cat_op .= qq|<option value="$no">$cat\n|;
		}
	}
	close(IN);

	header("画像データ修正＆削除");
	print <<EOM;
<div class="all">
<br />
EOM
	back_btn();
	print <<EOM;

<div class="sub-ttl"> 画像データ修正＆削除</div>
<ul>
<li>処理を選択して送信ボタンを押してください。
<li>ソ\ートのときは、順番内の数字を並び替えたい順に変更してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_men" value="1">
カテゴリ：
<select name="cat">
<option value="">カテゴリー未設定
$cat_op
</select>
<input type="submit" class="button" name="chg_cat" value="切替">
<div class="btn">
<input type="submit" class="button" name="job_edit" value="編集">
<input type="submit" class="button" name="job_sort" value="ソ\ート">
<input type="submit" class="button" name="job_dele" value="削除">
</div>
<table class="deco2">
<tr bgcolor="#BFBFFF">
  <th>選択</th>
  <th>順番</th>
  <th>カテゴリー</th>
  <th>タイトル</th>
  <th>画像</th>
</tr>
EOM

	# データ読み出し
	my $i = 0;
	open(IN,"$cf{datfile}") or &error("open err: $cf{datfile}");
	while (<IN>) {
		my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);
		next if ($in{cat} != $cat);

		$i++;
		print qq|<tr><td><input type="radio" name="no" value="$no"></td>|;
		print qq|<td><input type="text" name="sort$no" value="$i" size="3" style="ime-mode:inactive"></td>|;
		print qq|<td>$cat{$cat}</td>|;
		print qq|<td>$sub</td>|;
		print qq|<td><a href="$cf{uplurl}/$no$ex" target="_blank">画像</a></td></tr>\n|;
	}
	close(IN);

	print <<EOM;
</table>
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  カテゴリー設定
#-----------------------------------------------------------
sub data_cat {
	# 新規
	if ($in{add} && $in{cat_name} ne '') {

		# カテゴリー連番
		open(DAT,"+< $cf{numfile}") or error("open err: $cf{numfile}");
		my $data = <DAT>;
		my ($num,$cat) = split(/<>/, $data);
		$cat++;
		seek(DAT, 0, 0);
		print DAT "$num<>$cat";
		truncate(DAT, tell(DAT));
		close(DAT);

		# カテゴリ追加
		open(DAT,">> $cf{catfile}") or error("write err: $cf{catfile}");
		print DAT "$cat<>$in{cat_name}<>\n";
		close(DAT);

	# ソート
	} elsif ($in{sort}) {
		my (@log,@tmp);
		open(DAT,"+< $cf{catfile}") or error("open err: $cf{catfile}");
		while(<DAT>) {
			my ($no,$cat) = split(/<>/);

			push(@tmp,$in{"sort:$no"});
			push(@log,$_);
		}

		@log = @log[sort{$tmp[$a] <=> $tmp[$b]} 0 .. $#tmp];

		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	my ($edit,$del);
	foreach ( keys %in ) {
		if (/^edit:(\d+)/) {
			$edit = $1;
			last;
		} elsif (/^del:(\d+)/) {
			$del = $1;
			last;
		}
	}

	# 修正
	if ($edit) {
		my @log;
		open(DAT,"+< $cf{catfile}") or error("open err: $cf{catfile}");
		while(<DAT>) {
			my ($no,$cat) = split(/<>/);

			if ($edit == $no) {
				$_ = qq|$no<>$in{"cat:$no"}<>\n|;
			}
			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除
	} elsif ($del) {
		my @log;
		open(DAT,"+< $cf{catfile}") or error("open err: $cf{catfile}");
		while(<DAT>) {
			my ($no,$cat) = split(/<>/);
			next if ($del == $no);

			push(@log,$_);
		}
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# カテゴリー連番更新
		open(DAT,"+< $cf{numfile}");
		my $data = <DAT>;
		my ($num,$cat) = split(/<>/, $data);
		my $cate = $cat - 1;
		seek(DAT, 0, 0);
		print DAT "$num<>$cate";
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	header("メニューTOP ＞ カテゴリー設定");
	print <<EOM;

<div class="all">
<br />
EOM
	back_btn();
	print <<EOM;
<div class="sub-ttl"> カテゴリー設定</div>
<ul>
<li>カテゴリーを新規作成する場合は[新規]欄に名称を入力し、「新設」ボタンを押します。
<li>カテゴリー名を修正する場合は、カテゴリー名を修正し、「修正」ボタンを押します。
<li>並び替えを行う場合は、「順番」の数字を修正し、「順番変更」ボタンを押します。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="data_cat" value="1">
<input type="submit" class="button" name="sort" value="順番変更">
<table class="deco2">
<tr>
	<th nowrap>順番</th>
	<th nowrap>カテゴリー名</th>
</tr><tr>
	<td></td>
	<td>
		[新規]
		<input type="text" name="cat_name" size="40">
		<input type="submit" class="button" name="add" value="新設">
	</td>
</tr>
EOM

	my $i;
	open(IN,"$cf{catfile}") or error("open err: $cf{catfile}");
	while(<IN>) {
		$i++;
		my ($no,$cat) = split(/<>/);

		print qq|<tr><td><input type="text" name="sort:$no" value="$i" size="4"></td>\n|;
		print qq|<td><input type="text" name="cat:$no" value="$cat" size="40">\n|;
		print qq|<input type="submit" class="button" name="edit:$no" value="修正">\n|;
		print qq|<input type="submit" class="button" name="del:$no" value="削除"></td></tr>\n|;
	}
	close(IN);

	print <<EOM;
</table>
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  返信記事の管理
#-----------------------------------------------------------
sub mode_res {
	# 個別画面
	if ($in{no}) { res_disp(); }
	if ($in{time}) { res_disp(); }

	# カテゴリ
	my ($i,$cat_op,%cat);
	open(IN,"$cf{catfile}") or error("open err: $cf{catfile}");
	while(<IN>) {
		$i++;
		my ($no,$cat) = split(/<>/);

		# 初期カテゴリ
		if ($in{cat} eq '' && $i == 1) { $in{cat} = $no; }

		$cat{$no} = $cat;

		if ($in{cat} == $no) {
			$cat_op .= qq|<option value="$no" selected>$cat\n|;
		} else {
			$cat_op .= qq|<option value="$no">$cat\n|;
		}
	}
	close(IN);

	header("返信記事の管理");
	print <<EOM;
<div class="all">
<br />
EOM
	back_btn();
	print <<EOM;
<div class="sub-ttl"> 返信記事の管理</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_res" value="1">
カテゴリ：
<select name="cat">
$cat_op
</select>
<input type="submit" class="button" name="chg_cat" value="切替">
<ul>
<li>修正する返信のあるスレッドを選択してください。
</ul>
<input type="submit" class="button" value="選択する">
<table  class="deco2">
<tr>
  <th>選択</th>
  <th>タイトル</th>
  <th>レス数</th>
</tr>
EOM

	# データ読み出し
	open(IN,"$cf{datfile}") or &error("open err: $cf{datfile}");
	while (<IN>) {
		my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);
		next if ($in{cat} != $cat);

		print qq|<tr><td><input type="radio" name="no" value="$no"></td>|;
		print qq|<td>$sub</td>|;
		print qq|<td align="right">$res</td></tr>\n|;
	}
	close(IN);

	print <<EOM;
</table>
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  個別画面
#-----------------------------------------------------------
sub res_disp {
	$in{no} =~ s/\D//g;
	# 入力チェック
	$in{num} =~ s/\D//g;

	# 個別削除
	if ($in{job_dele} && $in{no}) {

		# 削除情報
		my %del;
		foreach ( $cgi->param('del') ) {
			$del{$_}++;
		}

		# データ読み出し
		my @data;
		open(DAT,"+< $cf{datadir}/$in{no}.cgi");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($num,$ex) = (split(/<>/))[0,8];
			# 削除情報マッチ
			if (defined($del{$num})) {
				unlink("$cf{resupldir}/$in{no}-$num$ex");
				unlink("$cf{resupldir}/$in{no}-$num-s$ex") if (-f "$cf{resupldir}/$in{no}-$num-s$ex");
				next;
			}
			push(@data,$_);
		}
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# レス数
		my $new_res = @data;

		# indexデータ
		my @file;
		open(DAT,"+< $cf{datfile}") or &error("open err: $cf{datfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			chomp;
			my ($no,$sub,$msg,$ex,$w,$h,$res,$time,$cat) = split(/<>/);

			if ($in{no} == $no) {
				$_ = "$no<>$sub<>$msg<>$ex<>$w<>$h<>$new_res<>$time<>$cat<>";
			}
			push(@file,"$_\n");
		}
		seek(DAT, 0, 0);
		print DAT @file;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 修正フォーム
	} elsif ($in{job_edit} && $in{no}) {

		# ログ展開
		my @log;
		open(IN,"$cf{datadir}/$in{no}.cgi") or &error("open err: $cf{datadir}/$in{no}.cgi");
		while (<IN>) {
			my ($num,$date,$name,$com,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

			if ($in{num} == $num) {
				@log = ($num,$date,$name,$com,$url,$host,$time,$cat,$ex,$w,$h,$pw);
				last;
			}
		}
		close(IN);

		res_edit(@log);

	# 修正実行
	} elsif ($in{job} eq "edit") {

		# ログ展開
		my (@data,$ex2,$w2,$h2);
		open(DAT,"+< $cf{datadir}/$in{no}.cgi") or &error("open err: $cf{datadir}/$in{no}.cgi");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			chomp;
			my ($num,$date,$name,$com,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

			if ($num == $in{num}) {

				# 画像アップ
				if ($in{upfile}) {
					($ex2,$w2,$h2) = res_upload($in{num});
				}

				# 添付削除
				if ($in{imgdel}) {
					unlink("$cf{resupldir}/$in{no}-$in{num}$ex");
					unlink("$cf{resupldir}/$in{no}-$in{num}-s$ex") if (-f "$cf{resupldir}/$in{no}-$in{num}-s$ex");
					$ex = $w = $h = '';
				}

				# 添付アップロードの場合
				if ($ex2) {
					if ($ex2 ne $ex) {
						unlink("$cf{resupldir}/$in{no}-$in{num}$ex");
						unlink("$cf{resupldir}/$in{no}-$in{num}-s$ex") if (-f "$cf{resupldir}/$in{no}-$in{num}-s$ex");
					}
					$ex = $ex2;
					$w = $w2;
					$h = $h2;
				}
				$_ = "$num<>$date<>$in{name}<>$in{comment}<>$in{url}<>$host<>$time<>$cat<>$ex<>$w<>$h<>$pw<>";
			}
			push(@data,$_);
		}
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		message("コメントの修正を完了しました");
	}

	header("レス記事編集");
	print <<EOM;
<div class="all">
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_res" value="1">
<input type="submit" class="button" value="&lt; 前画面">
</form>
</div>
<div class="sub-ttl"> レス記事編集</div>
<ul>
<li>削除する記事を選択してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_res" value="1">
<input type="hidden" name="no" value="$in{no}">
<input type="submit" class="button" name="job_edit" value="編集">
<input type="submit" class="button" name="job_dele" value="削除">

<table class="deco2">
<tr>
  <th>選択</th>
  <th>日付</th>
  <th>名前</th>
  <th>コメント</th>
  <th>添付</th>
</tr>
EOM

	# データ読み出し
	open(IN,"$cf{datadir}/$in{no}.cgi");
	while (<IN>) {
		my ($num,$date,$name,$com,$url,$host,$time,$cat,$ex,$w,$h,$pw) = split(/<>/);

		print qq|<tr><td><input type="checkbox" name="num" value="$num"></td>|;
		print qq|<td>$date</td><td>$name</td><td>$com</td>\n|;
		print qq|<td><a href="$cf{resuplurl}/$in{no}-$num$ex" target="_blank"><img src="$cf{resuplurl}/$in{no}-$num$ex" width="120" height="" alt="" /></a></td></tr>\n|;
	}
	close(IN);

	print <<EOM;
</table>
</form>
</blockquote>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  レス記事編集フォーム
#-----------------------------------------------------------
sub res_edit {
	my ($num,$date,$name,$com,$url,$host,$time,$cat,$ex,$w,$h,$pw) = @_;

	$com =~ s|<br( /)?>|\n|g;

	header("レス記事編集フォーム");
	print <<EOM;
<div class="all">
<br />
EOM
	back_btn();
	print <<EOM;
<div class="sub-ttl"> レス記事編集フォーム</div>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mode_res" value="1">
<input type="hidden" name="job" value="edit">
<input type="hidden" name="no" value="$in{no}">
<input type="hidden" name="num" value="$in{num}">
<table class="deco2">
<tr>
	<th class="item">お名前</th>
	<td><input type="text" name="name" size="28" class="reg-name" value="$name" /></td>
</tr><tr>
	<th class="item">コメント</th>
	<td>
		<textarea name="comment" class="reg-com">$com</textarea>
	</td>
</tr><tr>
	<th class="item">URL</th>
	<td><input type="text" name="url" size="60" class="reg-url" value="$url" /></td>
</tr><tr>
	<th class="item">添付</th>
	<td><input type="file" name="upfile" size="36" />&nbsp;&nbsp;&nbsp;
EOM
	if ($ex) {
		print qq|&nbsp; [<a href="$cf{resupldir}/$in{no}-$num$ex" target="_blank">添付</a>]\n|;
		print qq|<input type="checkbox" name="imgdel" value="1">削除\n|;
	}

	print <<EOM;
	</td>
</tr><tr>
	<th class="item" style="background:!col!"></th>
	<td>
		<input type="submit" value="送信する" class="large button" />
	</td>
</tr>
</table>
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" class="large button" value="管理画面に戻る">
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  コメント返信添付アップロード
#-----------------------------------------------------------
sub res_upload {
	my $num = shift;

	my $resnum;
	if ($in{no} =~ /^(\d+)$/) {
		$resnum = "$1";
	}

	my $fname = $cgi->param_filename('upfile');
	if ($fname =~ /(\.jpe?g|\.png|\.gif|\.bmp)$/i) {
		my $ex = $1;
		if ($ex eq '.jpeg') { $ex = '.jpg'; }

		# アップファイル定義
		my $imgfile = "$cf{resupldir}/$resnum-$num$ex";

		# 書き込み
		open(UP,"+> $imgfile") or error("up err: $imgfile");
		binmode(UP);
		print UP $in{upfile};
		close(UP);

		# 画像サイズ取得
		my ($w,$h);
		if ($ex eq ".jpg") { ($w,$h) = &j_size($imgfile); }
		elsif ($ex eq ".gif") { ($w,$h) = &g_size($imgfile); }
		elsif ($ex eq ".png") { ($w,$h) = &p_size($imgfile); }
		elsif ($ex eq ".bmp") { ($w,$h) = &b_size($imgfile); }

		chmod(0666,$imgfile);

		return ($ex,$w,$h);
	}
	return;
}

#-----------------------------------------------------------
#  画像アップロード
#-----------------------------------------------------------
sub upload {
	my $num = shift;

	my $fname = $cgi->param_filename('upfile');
	if ($fname =~ /(\.jpe?g|\.png|\.gif|\.bmp)$/i) {
		my $ex = $1;
		if ($ex eq '.jpeg') { $ex = '.jpg'; }

		# アップファイル定義
		my $imgfile = "$cf{upldir}/$num$ex";

		# 書き込み
		open(OUT,"+> $imgfile") or &error("画像アップ失敗");
		binmode(OUT);
		print OUT $in{upfile};
		close(OUT);

		# 画像サイズ取得
		my ($w,$h);
		if ($ex eq ".jpg") { ($w,$h) = &j_size($imgfile); }
		elsif ($ex eq ".gif") { ($w,$h) = &g_size($imgfile); }
		elsif ($ex eq ".png") { ($w,$h) = &p_size($imgfile); }
		elsif ($ex eq ".bmp") { ($w,$h) = &b_size($imgfile); }

		chmod(0666,$imgfile);

		return ($ex,$w,$h);
	}
	return;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  BMPサイズ
#-----------------------------------------------------------
sub b_size {
	my $bmp = shift;

	my $buf;
	open(BMP, "$bmp") || return (0,0);
	binmode(BMP);
	seek(BMP, 0, 0);
	read(BMP, $buf, 6);
	seek(BMP, 12, 1);
	read(BMP, $buf, 8);
	my ($w, $h) = unpack("VV", $buf);

	return ($w, $h);
}

#-----------------------------------------------------------
#  サイズ縮小
#-----------------------------------------------------------
sub resize {
	my ($w,$h,$max_w,$max_h) = @_;

	# 画像表示縮小
	if ($w > $max_w || $h > $max_h) {
		my $w2 = $max_w / $w;
		my $h2 = $max_h / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css">
<link href="cmn/admin.css" rel="stylesheet" type="text/css" />
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="$cf{cmnurl}/star.png" alt="star" class="icon">
	$cf{version} 管理画面 :: </div>
EOM
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
 [ <a href="https://www.kent-web.com/" target="_top">ImageAlbum : オリジナル公開終了</a> ]<br />
- <a href="https://www.transformsite.com/" target="_top">$cf{version} - Edited by TRANSFORM</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {

	print <<EOM;
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" class="button" value="▲管理TOP">
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub error {
	my $err = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="err">$err</p>
<hr width="350">
<form>
<input type="button" class="button" value="前画面に戻る" onclick="history.back()">
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

