# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ ImageAlbum v4.02 : init.cgi - 2013/06/15
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'Image Album v5.2';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#｜ 3. オリジナルスクリプト公開終了日：2022/04/21 (Thu)
#｜    [ last version : 4.02 ]
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Image Album v5.2 : init.cgi - 2022/10/01
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 基本設定
#===========================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0009';

# データディレクトリ【サーバパス】
$cf{admin_datadir} = './data';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# タイトル名
$cf{cgi_title} = "$cf{version}";

# タイトル下のメッセージ
$cf{ttl_msg} = '各画像のタイトルをクリックすると、返信の閲覧＆書き込みができます。';

# CGI表示部【URLパス】
$cf{album_cgi} = "./album.cgi";

# 管理部CGI【URLパス】
$cf{admin_cgi} = "./admin.cgi";

# コメント返信編集CGI【URLパス】
$cf{edit_cgi} = "./edit.cgi";

# コメント機能
# 0 : 許可しない
# 1 : 許可する
$cf{res_mode} = 1;

# データディレクトリ【サーバパス】
$cf{logdir} = './log';

# データファイル【サーバパス】
$cf{datfile} = './log/data.cgi';

# カテゴリファイル【サーバパス】
$cf{catfile} = "./log/cate.dat";

# 記事番号ファイル【サーバパス】
$cf{numfile} = './log/num.dat';

# 返信データディレクトリ【サーバパス】
$cf{datadir} = './log/data';

# 戻り先【URLパス】
$cf{backurl} = "../index.html";

# ログオフ時アドレス【URLパス】
$cf{logoffurl} = "./album.cgi?mode=enter";

# アップロードディレクトリ【サーバパス】
$cf{upldir} = './upl';

# アップロードディレクトリ【URLパス】
$cf{uplurl} = './upl';

# テンプレートディレクトリ
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# 返信アップロードディレクトリ【サーバパス】
$cf{resupldir} = './resupl';

# 返信アップロードディレクトリ【URLパス】
$cf{resuplurl} = './resupl';

# コメント返信：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{r_max_img_w} = 200;	# 横幅
$cf{r_max_img_h} = 120;	# 縦幅

# 最新記事TOP(リンク数)に掲載するタイトルリンクの数
$cf{max_topics} = 20;

# アーカイブの表示画面記事件数
$cf{archive_data} = 9;

# サイドメニュー内アーカイブの月数
$cf{max_archive} = 10;

# 文字コード自動判別（0=no 1=yes）
# → フォーム入力の文字コード判別を行う場合
$cf{conv_code} = 0;

# タイトルにNEWマークを付ける時間（時間単位）
$cf{new_time} = 6;

# NEWマークの表示形態
#  → 画像を使用しない場合には $cf{new_mark} = '<font color="#ff3300">new!</font>';
#     というように fontタグを記述してもよい
$cf{new_mark} = '<img src="./cmn/new.png" alt="">';

# 新着INDEX [NEWマーク]の表示形態
#  → 画像を使用する場合には $cf{new_mark2} = '<img src="./cmn/new.png" alt="">';
#     というように imgタグを記述してもよい
$cf{new_mark2} = '<font color="#ff3300">new!</font>';

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# 投稿があるとメール通知する : sendmail必須
#  0 : 通知しない
#  1 : 通知する
$cf{mailing} = 0;

# メール通知する際のメールアドレス
$cf{mailto} = 'xxx@xxx.xx';

# sendmailパス（メール通知する時）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 投稿受理最大サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 30720000;

# リスト画面の画像ファイルの最大サイズ
# → これを超える画像は縮小表示します
$cf{max_w} = 240;  # よこ
$cf{max_h} = 140;  # たて

# 個別詳細画面の画像ファイルの最大サイズ
# → これを超える画像は縮小表示します
$cf{max_w2} = 350;  # よこ
$cf{max_h2} = 240;  # たて

# TOPページ写真表示件数
# → 必ず「3」の倍数で指定
$cf{pg_max} = 6;

# １画像あたりに返信可能な記事数
# → これを超える記事は古い順に削除
$cf{res_max} = 30;

# 投稿制限（セキュリティ対策）
#  0 : しない
#  1 : 同一IPアドレスからの投稿間隔を制限する
#  2 : 全ての投稿間隔を制限する
$cf{regCtl} = 0;

# 制限投稿間隔（秒数）
#  → $regCtl での投稿間隔
$cf{wait} = 60;

# 記事の更新は method=post に限定する場合（セキュリティ対策）
# → 0=no 1=yes
$cf{postonly} = 1;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る）
#  → 拒否するホスト名又はIPアドレスを記述
#  → 記述例 $deny = '.anonymizer.com 211.154.120.';
$cf{denyhost} = '';

# クッキーID名（特に変更しなくてよい）
# → クッキー保存名
$cf{cookie_id3} = "Album_pwd";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 1;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captcha123';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "Mtg.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定値を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行処理
			$val =~ s/\r\n/<br>/g;
			$val =~ s/\r/<br>/g;
			$val =~ s/\n/<br>/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  コメント返信：画像リサイズ
#-----------------------------------------------------------
sub resize_res {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{r_max_img_w} || $h > $cf{r_max_img_h}) {
		my $w2 = $cf{r_max_img_w} / $w;
		my $h2 = $cf{r_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { &pwd_form; }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { &error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { &pwd_form; }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("write err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{logoffurl}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			&error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			pwd_form();
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!album_cgi!/$cf{album_cgi}/g;
	$tmpl =~ s/!cgi_title!/$cf{cgi_title}/g;
	$tmpl =~ s|!album_css!|$cf{cmnurl}/album.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl);
}


1;

